> For the complete documentation index, see [llms.txt](https://docs.lighter.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.lighter.xyz/evm/chain-info.md).

# Chain Info

This page is the canonical quick reference for Lighter EVM chain-level configuration.

## Chain metadata

* The EVM chain ID is `chainId = 19_529 = 0x4C49 = "LI"`.
* The Core chain ID is `300` on the devnet. Use it for signing Core transactions and deriving [EVM-to-Core transaction hashes](/evm/interop/message-passing/evm-and-core.md#core-transaction-hash), not the EVM chain ID.
* The EVM block time is 1 second.

## Differences from L1 EVM

See [Differences from L1 EVM](/evm/differences-from-l1-evm.md) for the full list of differences.

## Precompiles

Protocol-specific precompiles available to contracts on Lighter EVM.

| Name        | Address                                      | Purpose                         |
| ----------- | -------------------------------------------- | ------------------------------- |
| `READ_CORE` | `0x6600000000000000000000000000000000000000` | Synchronous reads of Core state |

## Predeploys

Protocol-owned contracts deployed at fixed addresses in the Lighter EVM (L2) genesis state. Unlike [preinstalls](#preinstalls), which are third-party contracts included for developer convenience, predeploys are first-party protocol components with privileged roles in the system.

Most predeploys hold an upgradeable proxy as code, upgradeable only via a system transaction. The fee vaults, [`LighterWrappedERC20V1`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/token/LighterWrappedERC20V1.sol), and `WETH9` are deployed as bare contracts, immutably.

| Name                                                                                                                                                          | Address                                      | Purpose                                                                                              |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------- | ---------------------------------------------------------------------------------------------------- |
| [`EvmInteropManager`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/interop/EvmInteropManager.sol)                        | `0x6600000000000000000000000000000000000001` | User-facing entrypoint for EVM and Core token ops                                                    |
| [`SequencerFeeVault`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/SequencerFeeVault.sol)                                | `0x6600000000000000000000000000000000000002` | Fee vault; `COINBASE` resolves to this address and it receives the priority fees                     |
| [`EvmToCoreMessenger`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/EvmToCoreMessenger.sol)                    | `0x6600000000000000000000000000000000000003` | Low-level EVM -> Core write messenger                                                                |
| [`EvmToL1Messenger`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/EvmToL1Messenger.sol)                        | `0x6600000000000000000000000000000000000004` | Low-level EVM -> L1 withdrawal messenger                                                             |
| [`EvmReplayableMessenger`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/replayable/EvmReplayableMessenger.sol) | `0x6600000000000000000000000000000000000005` | L1 -> EVM replayable message relay                                                                   |
| [`EvmEscrowGateway`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/gateways/evm/DefaultEvmEscrowGateway.sol)              | `0x6600000000000000000000000000000000000006` | Gateway for bridging EVM-native tokens                                                               |
| [`LighterWrappedERC20V1`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/token/LighterWrappedERC20V1.sol)                  | `0x6600000000000000000000000000000000000007` | Initial wrapped token implementation                                                                 |
| [`EvmMintGateway`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/gateways/l1/DefaultEvmMintGateway.sol)                   | `0x6600000000000000000000000000000000000008` | Gateway for bridging L1-native tokens                                                                |
| [`EvmToCoreEntrypoint`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/EvmToCoreEntrypoint.sol)                  | `0x6600000000000000000000000000000000000009` | User-facing entrypoint for account and order writes to Core                                          |
| [`BaseFeeVault`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/SequencerFeeVault.sol)                                     | `0x660000000000000000000000000000000000000a` | Fee vault; receives the EVM base-fee                                                                 |
| [`PubdataFeeVault`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/SequencerFeeVault.sol)                                  | `0x660000000000000000000000000000000000000b` | Fee vault; receives the L1 data fee                                                                  |
| `WETH9`                                                                                                                                                       | `0x660000000000000000000000000000000000000c` | Canonical wrapped ETH (`WETH`); standard `WETH9` interface                                           |
| [`GasPriceOracle`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/GasPriceOracle.sol)                                      | `0x660000000000000000000000000000000000000d` | Exposes the current `blobBaseFee` for the [L1 data fee](/evm/differences-from-l1-evm/l1-data-fee.md) |
| [`EvmL1RefundClaimer`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/EvmL1RefundClaimer.sol)                    | `0x660000000000000000000000000000000000000e` | Holds deposit refunds owed to L1-controlled Core accounts                                            |

## Preinstalls

Preinstalls are third-party contracts included in genesis for developer convenience.

| Name                                        | Address                                      |
| ------------------------------------------- | -------------------------------------------- |
| `Safe`                                      | `0x69f4D1788e39c87893C980c06EdF4b7f686e2938` |
| `SafeL2`                                    | `0xfb1bffC9d739B8D520DaF37dF666da4C687191EA` |
| `MultiSend`                                 | `0x998739BFdAAdde7C933B942a68053933098f9EDa` |
| `MultiSendCallOnly`                         | `0xA1dabEF33b3B82c7814B6D82A79e50F4AC44102B` |
| `SafeSingletonFactory`                      | `0x914d7Fec6aaC8cd542e72Bca78B30650d45643d7` |
| `Multicall3`                                | `0xcA11bde05977b3631167028862bE2a173976CA11` |
| `CreateX`                                   | `0xba5Ed099633D3B313e4D5F7bdc1305d3c28ba5Ed` |
| `Arachnid's Deterministic Deployment Proxy` | `0x4e59b44847b379578588920cA78FbF26c0B4956C` |
| `Permit2`                                   | `0x000000000022D473030F116dDEE9F6B43aC78BA3` |
| `ERC-4337 v0.6.0 EntryPoint`                | `0x5FF137D4b0FDCD49DcA30c7CF57E578a026d2789` |
| `ERC-4337 v0.6.0 SenderCreator`             | `0x7fc98430eaedbb6070b35b39d798725049088348` |
| `ERC-4337 v0.7.0 EntryPoint`                | `0x0000000071727De22E5E9d8BAf0edAc6f37da032` |
| `ERC-4337 v0.7.0 SenderCreator`             | `0xEFC2c1444eBCC4Db75e7613d20C6a62fF67A167C` |
| `ERC-4337 v0.8.0 EntryPoint`                | `0x4337084D9E255Ff0702461CF8895CE9E3b5Ff108` |
| `ERC-4337 v0.8.0 SenderCreator`             | `0x449ed7c3e6fee6a97311d4b55475df59c44add33` |
| `ERC-4337 v0.9.0 EntryPoint`                | `0x433709009B8330FDa32311DF1C2AFA402eD8D009` |
| `ERC-4337 v0.9.0 SenderCreator`             | `0x0a630a99df908a81115a3022927be82f9299987e` |

## System addresses

Addresses that are not contracts but appear as transaction senders in the Lighter EVM.

| Name                | Address                                      | Purpose                                         |
| ------------------- | -------------------------------------------- | ----------------------------------------------- |
| Core system address | `0x7fFFfFfFFFfFFFFfFffFfFfFfffFFfFfFffFFFFf` | Sender of every Core-originated EVM transaction |

## EVM execution parameters

* `TARGET_GAS_LIMIT`: `4,250,000`
* `ELASTICITY_MULTIPLIER`: `4` (`MAX_GAS_LIMIT = 17,000,000`)
* `BASE_FEE_MAX_CHANGE_DENOMINATOR`: `334`
* `INITIAL_BASE_FEE`: `1 gwei`
* `MAX_PRIORITY_GAS_LIMIT`: `10,000,000`
* `BASE_FEE_OVERHEAD`: `120,000`
* `BASE_FEE_SCALAR`: `9,700,000,000,000`
* `PUBDATA_GAS_PER_BYTE`: `70` (see [L1 Data Fee](/evm/differences-from-l1-evm/l1-data-fee.md))

## Protocol smart contracts

The following smart contracts are deployed on the private L1.

| Name                                                                                                                                                        | Address                                      | Purpose                                                    |
| ----------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------- | ---------------------------------------------------------- |
| [`ZkLighter`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/ZkLighter.sol)                                              | `0xd560b13C677E99499f496067a44ED355c69Aa51E` | L1 bridge                                                  |
| [`L1ReplayableMessenger`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/replayable/L1ReplayableMessenger.sol) | `0xD49203aFef6ED23b198371339E5055b79D74A95f` | L1 replayable message relay                                |
| [`L1InteropManager`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/interop/L1InteropManager.sol)                        | `0x8709B4047608BE3083dA13f703757A10f5B83A7c` | User-facing L1 entry point for sending tokens into Lighter |
| [`L1EscrowGateway`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/gateways/l1/DefaultL1EscrowGateway.sol)               | `0xf59c7a46614c343E51d95948E8686769eC8e9696` | Gateway for bridging L1-native tokens                      |
| [`L1MintGateway`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/gateways/evm/DefaultL1MintGateway.sol)                  | `0xc99AF9C0e19C8984c36b4CaFc7963B500542DF7c` | Gateway for bridging EVM-native tokens                     |
| [`L1CoreMessaging`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/messaging/L1CoreMessaging.sol)                        | `0x1eaeA4982372d591228D2a5465d55d3b26e809f9` | Messaging relay between Core and L1                        |
| [`Governance`](https://github.com/elliottech/lighter-contracts/blob/lighter-evm-devnet/contracts/Governance.sol)                                            | `0xAc2499795E7b45F21634C221496a5085017d141c` | Protocol governance                                        |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.lighter.xyz/evm/chain-info.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
